#!/usr/bin/env python3
# Distutils script for Morseall
# to test an install in a build tree:  python3 setup.py j

import setuptools
from distutils.core import setup
import src.MorseCode
from glob import glob

setup(name = 'morseall',
	version      = src.MorseCode.version,
	description  = "Control your computer by tapping Morse Code on the mouse",
	url          = src.MorseCode.url,
	#author       = src.MorseCode.author,
	#author_email = src.MorseCode.author_email,
	# Executable files 
	scripts      = ['morseall', 'keymap'],
	# Python packages
	packages     = ['morseall'],
	# Map to python packages
	package_dir  = {'morseall':'src'},
	# The Dir prefix is /usr/ when building a .deb or .rpm
	# The Dir prefix is /usr/local/ when installed by 'setup.py install'
    # data_files = [(Destination_Dir, [ Files to copy there ...]), ...]
	data_files = [ 
		# Man page
		('share/man/man1', ['morseall-data/morseall.1']),
		# Config files
		('share/morseall', glob('morseall-data/*.conf')),
		('share/morseall', ['morseall-data/bashrc']),
        # Docs
        # README.md COPYING and NEWS are included by debian/docs 
        # The .deb puts doc files in /usr/share/doc/morseall/
		# Images
		('share/morseall', glob('morseall-data/*.png')),
		# Sound
		('share/morseall/sound', glob('morseall-data/sound/*.opus')),
		# Application Icon
		('share/applications/desktop', ['morseall-data/morseall.desktop']),
		# Permission to insert keystrokes and mouse events
		('/etc/udev/rules.d', ['morseall-data/99-udev-evdev-access.rules']),
	],
)
