#!/usr/bin/env python3
# For more on Curses, see http://docs.python.org/howto/curses.html
import sys
import curses
#from . import MorseCode
import MorseCode

"""
# Enable this section when debugging, since curses hides the err msgs
pages = m.help_pages(rows = 20, columns = 80)
class initscr:
	def getmaxyx(self):
		return 25,80
	def clear(self):
		print("clear")
	def move(self,x,y):
		print("move",x,y)
	def addstr(self,text):
		print(text)
	def refresh(self):
		print("refresh")
	def getkey():
		return raw_input()[:1]
	def endwin():
		print("endwin")
s = curses = initscr()
"""

def main_loop(c,m,s):
	n = 0
	while 1:
		# compute the size of everything 
		rows,columns = s.getmaxyx()
		# Curses gives an error when addstr tries to use the last column
		# so we sorten the columns by one here.
		columns = columns -1
		pages = m.help_pages(rows = rows-1, columns = columns)

		# If we made the sceen bigger, we may have fewer pages!
		if n >= len(pages): 
			n = len(pages)-1

		# display our page
		s.clear()
		s.move(0,0)
		s.addstr(pages[n])

		# add the text at the bottom of the help page
		#text = "Morseall keymap [%d of %d]" % (n+1, len(pages))
		#s.move(rows-2,0)
		#s.addstr(text[:columns])
		s.move(rows-1,0)
		text = "Press space for more ..-- Morseall Keymap  page %d of %d" 
		text %= (n+1, len(pages))
		s.addstr(text[:columns])
		s.refresh()

		c = s.getkey()
		if c in ["q",curses.KEY_BREAK]:
			break
		elif c in [" ","n","j","f","e","t",curses.KEY_ENTER]:  
			# Go to next screen (10 is Return)
			n = n + 1
			if n >= len(pages):
				break
		elif c in ["b","p","k",curses.KEY_UP, curses.KEY_PPAGE]:
			# Go to previous screen
			n = n - 1
			if n < 0: 
				n = 0
				curses.beep()
		elif c in [curses.KEY_REFRESH]:
			# ^L which means redraw in most contexts
			continue	
		elif c == [curses.KEY_RESIZE]:  
			# This hapens when the display resizes!
			continue	
		else:
			#open('log.log','w').write("curses = %s\n" % c)
			continue	


def main():
	"Prints morse code sequences to the screen for each possible key"
	c = MorseCode.ConfigFile()
	m = MorseCode.MorseCode(c)
	s = curses.initscr()
	curses.noecho()
	curses.cbreak()
	s.keypad(1)
	try:
		main_loop(c,m,s)
	finally:
		s.keypad(0)
		curses.nocbreak()
		curses.echo()
		curses.endwin()



if __name__ == "__main__":
	main()

