#!/usr/bin/env python3 
import Xlib
import Xlib.ext
import Xlib.ext.xtest

from Xlib import X
from Xlib.ext.xtest import fake_input
from Xlib.display import Display
import time

class XMouser:

	def __init__(self, callback):
		'Call the callback when something happens...'
		self.d = Display()
		self.callback = callback


	def click(self, button=1, seconds=0):
		"""Click a button (press and release)

		1/2/3 = left / middle / right
		4/5 = vertical wheel scroll
		6/7 = horzontal wheel scroll
		"""
		fake_input(self.d, X.ButtonPress, button)
		self.d.sync()
		if seconds:
			time.sleep(seconds)
		fake_input(self.d, X.ButtonRelease, button)
		self.d.sync()

	def move(self, x = 0, y = 0):
		"move the mouse"


	def set_grab(self, grab_flag=True):
		"""Grab or un-gram the mouse"
		if not grab_flag:
			XUnGrabPointer()
			return
		XGrabPointer(self.d,
			grab_window = None,
			owner_events = False,
			event_mask = 0,
			# do not allow normal processing of mouse events
			pointer_mode = GrabModeSync,
			cursor = ??,
			confine_to = None,
		)
		"""
    

if __name__ == '__main__':
    print('XMouser allows inserting fake mouse events.')
    print('To demonstrate, I will Click something somewhere on the screen.')
    [[print(i), time.sleep(1)] for i in [3,2,1]]
    m = XMouser(None)
    m.click(1)
    m.click(3, .5)

